
#include "base.hpp"

struct fmt_cor {
	struct promise_type {
		char * _value = nullptr;

		fmt_cor get_return_object() {
			return fmt_cor(std::experimental::coroutine_handle<promise_type>::from_promise(*this));
		}

		auto initial_suspend() { return suspend_never(); }
		auto final_suspend()   {
			return suspend_always();
		}

		void return_void() {}

		auto yield_value(char & value) {
			_value = &value;
			return suspend_always();
		}

		void unhandled_exception() {}
	};

	std::experimental::coroutine_handle<promise_type> _coroutine = nullptr;

	explicit fmt_cor(std::experimental::coroutine_handle<promise_type> coroutine)
		: _coroutine(coroutine)
	{}

	~fmt_cor() {
		if(_coroutine) { _coroutine.destroy(); }
	}

	fmt_cor() = default;
	fmt_cor(fmt_cor const &) = delete;
	fmt_cor& operator=(fmt_cor const &) = delete;

	fmt_cor(fmt_cor&& other) {
		std::swap(_coroutine, other._coroutine);
	}

	fmt_cor& operator=(fmt_cor&& other) {
		if(&other != this) {
			_coroutine = other._coroutine;
			other._coroutine = nullptr;
		}
		return *this;
	}

	void send(char a) {
		assert(_coroutine.promise()._value);
		*_coroutine.promise()._value = a;
		_coroutine.resume();
	}
};

fmt_cor Fmt() {
	char c;
	int g, b;
	for(;;) {
		for(g = 0; g < 5; g++) {
			for(b = 0; b < 4; b++) {
				co_yield c;
				std::cout << c;
			}
			std::cout << "  ";
		}
		std::cout << std::endl;
	}
}

int main() {
	auto fmt = Fmt();
	for(int i = 0; i < 41; i++) {
		fmt.send('a');
	}
}